LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L1_BNROM IS
  PORT (
    clk : IN STD_LOGIC;
    coefs : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    address : IN unsigned(3 DOWNTO 0));
END L1_BNROM;

ARCHITECTURE RTL OF L1_BNROM IS

  TYPE ROM_mem IS ARRAY (0 TO 15) OF STD_LOGIC_VECTOR(31 DOWNTO 0);

  signal ROM_content : ROM_mem :=
  --7.9
  --Contenido bias || scale
  --YA ESTAN DESPLAZADOS
  (
  0 => "0000001001001100" & "0000111000100011",
  1 => "0000010000110111" & "0001100111111011",
  2 => "1110011110001110" & "0001001011100110",
  3 => "0000000101001001" & "0000100011111111",
  4 => "0000000101110100" & "0000101001111011",
  5 => "1111011110100010" & "0011101111101101",
  6 => "0000011111011001" & "0100110011100110",
  7 => "1111010110000101" & "0100101100100111",
  8 => "0000010010001110" & "0011111000110001",
  9 => "0000010010111101" & "0010101110111000",
  10 => "0000001000000101" & "0001100101111111",
  11 => "0000001001010001" & "0001101111110101",
  12 => "0000001000101101" & "0001101000001100",
  13 => "0000000111011010" & "0000101111011100",
  14 => "1111111111010111" & "0010101111100011",
  15 => "0000001100100000" & "0001101111001001");

  attribute rom_style : string; 
  attribute rom_style of ROM_content : signal is "block";

BEGIN
  proc_name : PROCESS (clk)
  BEGIN
    IF rising_edge(clk) THEN
      coefs <= ROM_content(to_integer(address));
    END IF;
  END PROCESS proc_name;

END RTL;